HDU 4996 Revenge of LIS(DP)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4996

题意:求1到n的全排列中,有多少个排列的最长上升子列长度为K?

思路:对于当前的最长上升子列,我们记录最后一个值得最小值即可。因此我们用2^n的状态表示当前最长上升子列中使用了哪些数字,且字典序最小。前n-1个数字之后,我们枚举最后一个位置的数字为[1,n]中每个数字,设为k,那么我们只要将前面[1,n-1]组成的数列中所有大于等于k的数字加一即可。

int n,k;

i64 f[22][22];
i64 dp[1<<22],tmp[1<<22];

int cal(int x)
{
    int ans=0;
    int i;
    for(i=0;i<20;i++) if(x&(1<<i)) ans++;
    return ans;
}

void init()
{
    dp[1]=1;
    f[1][1]=1;
    int i,j;
    for(i=1;i<18;i++)
    {

        for(j=0;j<(1<<i);j++) tmp[j]=dp[j];
        for(j=0;j<(1<<(i+1));j++) dp[j]=0;
        for(j=0;j<(1<<i);j++) if(tmp[j])
        {
            int k;
            for(k=0;k<=i;k++)
            {
                int tot=0;
                int c[20];
                int t;
                for(t=0;t<i;t++) if(j&(1<<t)) c[tot++]=t;
                for(t=0;t<tot;t++) if(c[t]>=k) c[t]++;
                c[tot++]=k;

                for(t=0;t<tot;t++) if(c[t]>k)
                {
                    c[t]=k;
                    break;
                }

                int st=0;
                for(t=0;t<tot;t++) st|=1<<c[t];
                dp[st]+=tmp[j];
            }
        }
        for(j=0;j<(1<<(i+1));j++) f[i+1][cal(j)]+=dp[j];
    }
}

int main()
{
    init();
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d",&n,&k);
        printf("%I64d\n",f[n][k]);
    }
}
时间: 2024-10-13 03:02:35

HDU 4996 Revenge of LIS(DP)的相关文章

hdu 5087 Revenge of LIS II(LIS)

题目连接:hdu 5087 Revenge of LIS II 题目大意:给定一个序列,求第2长的LIS长度. 解题思路:用o(n^2)的算法求LIS,每个位置维护两个值,最大和最小即可.注意的是dp[0]中的最大第二大不能都复制成0. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 1005; int N, A[maxn],

HDU 5087 Revenge of LIS II(次长上升子序列)

题意  求一个序列的所有上升子序列中第二长的那个的长度 简单的dp   d[i]表示以第i个数结尾的最长上升子序列的长度  c[i]表示到达d[i]的方法数  如序列1 1 2  d[3]=2,c[3]=2  因为选1 3位置和 2 3位置的都可以得到d[3]=2 递推过程很简单 d[i]=max{d[j]+1}其中a[i]>a[j]&&i>j 最后看d[1~n]中最大的数出现了几次  出现了不止一次就直接输出否则就减一输出咯 #include <cstdio> #

hdu 5087 Revenge of LIS II lcs变形

点击打开链接链接 Revenge of LIS II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1028    Accepted Submission(s): 334 Problem Description In computer science, the longest increasing subsequence proble

hdu 5087 Revenge of LIS II(BestCoder Round #16)

Revenge of LIS II                                                  Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 528    Accepted Submission(s): 173 Problem Description In computer science, th

HDU 5087 Revenge of LIS II(次大递增子序列)

Revenge of LIS II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1258    Accepted Submission(s): 423 Problem Description In computer science, the longest increasing subsequence problem is to f

HDU 5078 Revenge of LIS II(dp LIS)

Problem Description In computer science, the longest increasing subsequence problem is to find a subsequence of a given sequence in which the subsequence's elements are in sorted order, lowest to highest, and in which the subsequence is as long as po

hdu 5087 Revenge of LIS II (DP)

题意: N个数,求第二长上升子序列的长度. 数据范围: 1. 1 <= T <= 1002. 2 <= N <= 10003. 1 <= Ai <= 1 000 000 000 思路: 数据给的很暧昧,用n^2的算法可以过.故用n^2算法.只要在DP过程中记录得到f[i]是否只有一种方法即可.详看代码. 代码: int T,n; int a[1005],f[1005]; bool NOTalone[1005]; int main(){ //freopen("t

hdu 5087 Revenge of LIS II

http://acm.hdu.edu.cn/showproblem.php?pid=5087 题意求第二长的上升序列. 在求最长上升序列的同时加上一个数组,来记录以i为结尾的有多少条序列.如果n+1为结尾有多条,就输出dp[n+1]-1; 否则在这个最长的序列上每一个节点是不是都是num[i]==1,如果是,就输出dp[n+1]-2;否则输出dp[n+1]-1: 1 #include <cstdio> 2 #include <cstring> 3 #include <algo

hdu 5087 Revenge of LIS II ( LIS ,第二长子序列)

链接:hdu 5087 题意:求第二大的最长升序子序列 分析:这里的第二大指的是,全部的递增子序列的长度(包含相等的), 从大到小排序后.排在第二的长度 BestCoder Round #16 上的第二题,注意  1 1 2 这组数据,答案应为2 思路1.每次将最长的两个上升子序列长度记录.最后再排序,取第二大的就可以 思路2.假设最长的上升子序列长度(ans)唯一,那第二大应为ans-1 否则,第二大的就为 ans [cpp] view plaincopyprint? #include<std